<?xml version="1.0"?>
<xs:schema targetNamespace="urn:ddb:expandingpulley"
           xmlns='urn:ddb:expandingpulley'           
           xmlns:xs="http://www.w3.org/2001/XMLSchema" >

 <xs:include schemaLocation="commonDefs.xs" />

 <xs:element name="Data">
  <xs:complexType>
   <xs:sequence>
    <xs:element ref="Instance"  />
    <xs:element ref="Command"/>
    <xs:element ref="Autoload" minOccurs="0" maxOccurs="unbounded" />
    <xs:choice minOccurs="0" maxOccurs="unbounded">
     <xs:element ref="Logon" />
     <xs:element ref="ProcessList" />
     <xs:element ref="IntermediateSuccess" />
     <xs:element ref="Error" />
    </xs:choice>
    <xs:choice>
     <xs:element ref="Success" />
     <xs:element ref="Failure" />
    </xs:choice> 
   </xs:sequence>
  </xs:complexType>
 </xs:element>

 <xs:element name="Logon">
  <xs:complexType>
   <xs:attribute name="handle"       type="feHex" />
   <xs:attribute name="alias"        type="xs:string" />
   <xs:attribute name="lptimestamp"  type="xs:dateTime" /> 
  </xs:complexType>
 </xs:element>
 
 <xs:element name="ProcessList">
  <xs:complexType>
	<xs:sequence minOccurs="1" maxOccurs="unbounded">
		<xs:element ref="Process" />
	</xs:sequence>	
	<xs:attribute name="lptimestamp"  type="xs:dateTime" /> 
  </xs:complexType>
 </xs:element>
 
 <xs:element name="Process">
  <xs:complexType>	
	<xs:attribute name="id"  type="xs:nonNegativeInteger" /> 
	<xs:attribute name="name"  type="xs:string" /> 
	<xs:attribute name="user"  type="xs:string" /> 
  </xs:complexType>
 </xs:element>
</xs:schema>
