<?xml version="1.0"?>
<xs:schema targetNamespace="urn:ddb:expandingpulley"
           xmlns='urn:ddb:expandingpulley'           
           xmlns:xs="http://www.w3.org/2001/XMLSchema" >

 <xs:include schemaLocation="commonDefs.xs" />

 <xs:element name="Data">
  <xs:complexType>
   <xs:sequence>
    <xs:element ref="Instance"  />
    <xs:element ref="Command"/>
    <xs:element ref="Autoload" minOccurs="0" maxOccurs="unbounded" />
    <xs:choice minOccurs="0" maxOccurs="unbounded">
     <xs:element ref="LotusNotesMailUsers" />
     <xs:element ref="Error" />
    </xs:choice>
    <xs:choice>
     <xs:element ref="Success" />
     <xs:element ref="Failure" />
    </xs:choice> 
   </xs:sequence>
  </xs:complexType>
 </xs:element>

 <xs:element name="LotusNotesMailUsers">
  <xs:complexType>
    <xs:sequence>
      <xs:element ref='User' minOccurs='0' maxOccurs='unbounded'/>
    </xs:sequence>
      <xs:attribute name="lptimestamp"  	type="xs:dateTime"/>
  </xs:complexType>
 </xs:element>

 <xs:element name="User">
  <xs:complexType>
    <xs:sequence>
      <xs:element ref='FirstName' minOccurs='0' maxOccurs='1'/>
      <xs:element ref='LastName' minOccurs='0' maxOccurs='1'/> 
      <xs:element ref='MailFile' minOccurs='0' maxOccurs='1'/>
      <xs:element ref='InternetAddress' minOccurs='0' maxOccurs='1'/>
   </xs:sequence>
  </xs:complexType>
 </xs:element>

 <xs:element name="FirstName">
   <xs:complexType>
     <xs:simpleContent>
       <xs:extension base='xs:string'>
         <xs:attribute name='error' type='feHex'/>
       </xs:extension>
     </xs:simpleContent>
   </xs:complexType>
 </xs:element>

 <xs:element name="LastName">
   <xs:complexType>
     <xs:simpleContent>
       <xs:extension base='xs:string'>
     	 <xs:attribute name='error' type='feHex'/>
       </xs:extension>
     </xs:simpleContent>
   </xs:complexType>
 </xs:element>

 <xs:element name="MailFile">
   <xs:complexType>
     <xs:simpleContent>
       <xs:extension base='xs:string'>
         <xs:attribute name='error' type='feHex'/>
       </xs:extension>
     </xs:simpleContent>
   </xs:complexType>
 </xs:element>

 <xs:element name="InternetAddress">
   <xs:complexType>
     <xs:simpleContent>
       <xs:extension base='xs:string'>
         <xs:attribute name='error' type='feHex'/>
       </xs:extension>
     </xs:simpleContent>
   </xs:complexType>
 </xs:element>

</xs:schema>

