<?xml version="1.0"?>
<xs:schema targetNamespace="urn:ddb:expandingpulley"
           xmlns='urn:ddb:expandingpulley'           
           xmlns:xs="http://www.w3.org/2001/XMLSchema" >

 <xs:include schemaLocation="commonDefs.xs" />

 <xs:element name="Data">
  <xs:complexType>
   <xs:sequence>
    <xs:element ref="Instance"  />
    <xs:element ref="Command"/>
    <xs:element ref="Autoload" minOccurs="0" maxOccurs="unbounded" />
    <xs:choice minOccurs="0" maxOccurs="unbounded">
     <xs:element ref="ErrLog" />
     <xs:element ref="EventLog" />
     <xs:element ref="Error" />
    </xs:choice>
    <xs:choice>
     <xs:element ref="Success" />
     <xs:element ref="Failure" />
    </xs:choice> 
   </xs:sequence>
  </xs:complexType>
 </xs:element>

 <xs:element name="EventLog">
  <xs:complexType>
   <xs:simpleContent>
    <xs:extension base="xs:string">
     <xs:attribute name="remoteLocalTime"         type="xs:dateTime" />
     <xs:attribute name="mostRecentRecordNum"     type="xs:nonNegativeInteger" />
     <xs:attribute name="numRecords"              type="xs:nonNegativeInteger" />
     <xs:attribute name="oldestRecordNum"         type="xs:nonNegativeInteger" />
     <xs:attribute name="mostRecentRecTime"       type="xs:string" />
     <xs:attribute name="lptimestamp"             type="xs:dateTime" />
    </xs:extension>
   </xs:simpleContent>
  </xs:complexType>
 </xs:element>

 <xs:element name="ErrLog">
  <xs:complexType>
   <xs:simpleContent>
    <xs:extension base="xs:string">
     <xs:attribute name="osError"                 type="xs:nonNegativeInteger" />
     <xs:attribute name="lptimestamp"             type="xs:dateTime" />
    </xs:extension>
   </xs:simpleContent>
  </xs:complexType>
 </xs:element>

</xs:schema>
